<?php
namespace OrganizationsManagement\Util;

class Messages {
    /** Success messages **/
    const SUC_SAVED = "Dados salvos com sucesso!";
    const SUC_REMOVED = "Dados removidos com sucesso!";
    const SUC_REMOVED_SIMPLE = "Registro removido com sucesso!";
    const SUC_ROWS_EXPORTED = "{{rowCount}} registro(s) exportado(s).";
    const SUC_ROWS_UPDATED  = "{{rowCount}} registro(s) atualizados(s).";
    const SUC_ROWS_NEW_CODE_EXPORTED = "{{rowCount}} registro(s) de novo código exportado(s).";
    const SUC_ROWS_REVERTED = "{{rowCount}} registro(s) revertido(s).";
    const SUC_SEQUENCE_UPDATED = "Sequência atualizada.";
    const SUC_ACTIVATE_NOT_SAAS = "Organização não Saas ativada com sucesso";
    const SUC_REQUEST_DEACTIVATION_ORGANIZATION = "Solicitação enviada com sucesso.";
    const SUC_IGNORED_ERROR = "Erro ignorado!";

    /** Error messages **/
    const ERR_NOT_FILTER_SAAS = "";
    const ERR_NOT_SAVED = "Os dados não puderam ser salvos.";
    const ERR_NOT_SAVED_ALREADY = "Esta organização já está cadastrada, porém está inativa.";
    const ERR_NOT_SAVED_ALREADY_ACTIVE = "Já existe uma organização cadastrada com essa inscrição jurídica (CNPJ/CPF).";
    const ERR_NOT_REMOVED_EXPLANATION = "Não foi possível remover os dados, pois ";
    const ERR_ORG_NOT_REMOVED_DUE_CONSTRAINT = "Algumas organizações não puderam ser excluídas por possuírem relacionamentos internos.";
    const ERR_ORIGIN_ORG_EQUAL_DESTINY_ORG = "A \"Organização de Origem\" não pode ser igual à \"Organização de Destino\".";
    const ERR_NOT_EMPTY_TABLES_DATA_EXPORTATION = "Para realizar a exportação, as seguintes tabelas devem estar vazias:<br/><br/><u>\"{{tables}}\"</u>.";
    const ERR_NOT_SAVE_TABLE_OPERATOR_CONSTRAINT = "Essa tabela não pode ser inserida porque possue referência da tabela \"Operador\"";
    const ERR_NOT_DELETE_SLACLIENTE = "Alguns Parâmetros SLA não podem ser excluídos porque tem alertas relacionados. Para proseguir com essa operação é necessário excluír todos os Alertas cadastrados para o(s) Parâmetro(s) SLA em questão.";
    const ERR_NOT_DELETE_PERMISSION_SLACLIENTE = "Operação de exclusão não é permitida para esse(s) Parâmetro(s) SLA.";

    const ERR_NOT_SAVE_ORGANIZATION_BECAUSE_CUSTOMER_NOT_FOUND = 'Não foi possível criar a organização, pois o código informado não corresponde a um cliente cadastrado!';
    const ERR_NOT_SAVE_ORGANIZATION_BECAUSE_CUSTOMER_NOT_HAS_MAIN_ADDRESS = 'Não foi possível criar a organização, pois o cliente informado não possui um endereço principal cadastrado!';
    const ERR_NOT_SAVE_ORGANIZATION_BECAUSE_PRODUCT_NOT_FOUND_EXPLANATION = 'Não foi possível criar a organização, pois o código a seguir não corresponde a um produto cadastrado: ';
    const ERR_NOT_SAVE_ORGANIZATION_BECAUSE_ELEMENT_NOT_FOUND_EXPLANATION = 'Não foi possível criar a organização, pois o produto "{{productName}}" não possui um elemento com a uniqueId a seguir: ';
    const ERR_NOT_SAVE_ORGANIZATION_BECAUSE_OCCUR_UNKNOWN_ERROR_SAVE_PRODUCT = 'Não foi possível criar a organização, pois ocorreu um erro desconhecido ao associar o(s) produto(s) a organização!';
    const ERR_NOT_SAVE_ORGANIZATION_BECAUSE_PRODUCT_ID_NOT_INFORMED = 'Não foi possível criar a organização, pois não foi informado o ID do produto!';
    const ERR_NOT_SAVE_ORGANIZATION_BECAUSE_EXPIRATION_DATE_INVALID = 'Não foi possível atualizar os elementos pois a data de validade não foi informada ou está em um formato incorreto.';
    const ERR_NOT_SAVE_ORGANIZATION_BECAUSE_SYSTEM_PRODUCT_LINE_NOT_FOUND = 'Não foi possível salvar os registros do contrato pois não há sistemas relacionados com os elementos do produto "{{productName}}".';
    const ERR_NOT_SAVE_ORGANIZATION_BECAUSE_PRODUCT_LINE_PARAMS_NOT_FOUND = 'Não foi possível salvar os registros do contrato pois os seguintes parâmetros não foram informados:<br/><br/>';
    const ERR_SECONDARY_ORGANIZATION_SAVE_AS_PRIMARY = "Organização Secundária não pode ser selecionada como Primária.";
    const ERR_PRIMARY_ORGANIZATION_WITH_RELATED_ORGANIZATIONS = "Essa organização não pode ser Secundária porque já possui organizações secundárias relacionadas";
    const ERR_SAME_ACTION_ORDER_COMMAND = "Já existe um comando para essa Ação e Hospedagem com essa Ordem.<br/>Informe uma Ordem diferente.";
    const ERR_URL_UNDEFINED = "Ocorreu um erro na conexão com a URL cadastrada.<br/>Verifique se ela está correta.";
    const ERR_EMPTY_URL = "URL para integração com SM não cadastrada";

    const ERR_NOT_SYNCHRONIZE_PRODUCT_WITHOUT_ELEMENTS = "O produto não possui elementos para sincronizar!";
    const ERR_NOT_SYNCHRONIZE_PRODUCT_NOT_FOUND = "O produto informado não foi encontrado!";
    const ERR_SEND_COLLECTION_TO_SM = "Ocorreu um erro durante o envio da coleta para o SM.";

    const JSON_ERROR_DEPTH = "O arquivo informado está com a profundidade máxima da pilha excedida.";
    const JSON_ERROR_SYNTAX = "O arquivo informado está com erro de sintaxe ou não é um arquivo JSON.";
    const JSON_ERROR_CTRL_CHAR = "O arquivo informado está com erro de caracteres de controle.";
    const JSON_ERROR_STATE_MISMATCH = "O arquivo informado está inválido ou mal formado.";
    const JSON_ERROR_UTF8 = "O arquivo informado está com caracteres UTF-8 mal formado.";
    const JSON_ERROR_UNKNOWN = "Ocorreu um erro desconhecido.";

    const ERR_RESTRICTION_CHANGES_NOT_SAVED = "Não foi possível salvar as alterações, pois a restrição não existe!";
    const ERR_NONE_IP_INFORMED = "Nenhum IP foi informado!";
    const ERR_IP_INVALID = "O IP informado é inválido!";
    const ERR_IP_ALREADY_REGISTERED = "O IP informado já está cadastrado para esta organização!";
    const ERR_NOT_ASSOCIATED_ORGANIZATION_PRODUCTS = "Não existem produtos associados à essa organização.";
    const ERR_OPERATOR_NOT_FOUND_GENERATE_PASSWORD = "Operador não encontrado na base Teknisa. Verifique se o e-mail cadastrado está correto.";
    const ERR_OPERATOR_NOT_FOUND_GENERATE_PASSWORD_ORG = "Operador não encontrado na base da Organização. Verifique se o e-mail cadastrado está correto.";
    const ERR_PRIMATY_ORGANIZATION_NOT_PREPARED = "Para definir essa organização como preparada é necessário preparar a base da organização primária.";
    const ERR_NOT_PRE_INITIAL_DATA = "Não foram encontrados registros básicos necessários.<br/>Verifique se os pré dados iniciais foram executados.";
    const ERR_ORGANIZATION_OPERATOR_NOT_FOUND = "O operador criado durante a preparação dessa organização não foi encontrado.";
    const ERR_EXISTS_OTHER_DEFAULT_PARAMETER_WITH_TYPE = "Existem parâmetros padrões do coletor cadastrados para a hospedagem escolhida. <br> Não é possível cadastrar um novo registro para essa hospedagem.";
    const ERR_EXISTS_OTHER_TEKNISA_VARIABLE_MEASURE = "A medida variável selecionada está parametrizada para ser coletada na Teknisa. <br> Nesse caso, só é possível cadastrar uma configuração por produto e já existe um registro relacionado com essa medida.";

    const ERR_INACTIVE_ELEMENT = "Os dados dos elementos não liberados para essa organização não podem ser alterados.<br/> Desmarque-os para realizar essa ação.";
    const ERR_FUNC_ONLY_LOGIN = "Sistema indisponível para o operador informado.";
    const ERR_COMMANDS_WITHOUT_URLS = "Os comandos abaixo não possuem URLs cadastradas: <br/> {{commands}}";
    const ERR_NOT_COMMANDS_ENVIRONMENT_AND_ACTION = "Nenhum comando cadastrado para o ambiente da organização e ação escolhida.";
    const ERR_EMPTY_RESULT_CALL_WEBSERVICE = "Erro desconhecido.";
    const ERR_NO_PRODUCT_ORGANIZATION_RELATION = "Não foi encontrada relação entre o produto e a organização selecionada.";
    const ERR_OPERATOR_RELATED_OTHER_ORGANIZATION = "O e-mail do operador informado já existe relacionado à outra organização.";

    const ALE_EMPTY_PRODUCT_VARIABEL_MEASURE_CONFIG         = "As configurações da coleta de medidas variáveis não foram cadastradas para esse produto.";
    const ALE_EMPTY_CONTRACTS_VARIABEL_MEASURE              = "Atenção! <br> Esse produto está configurado para realizar a coleta de medidas variáveis mas não foram detectados contratos com registro de medição para o mês atual.";
    const ALE_EMPTY_PRODUCTION_SERVER_VARIABEL_MEASURE      = "Atenção! <br> Esse produto possui contratos em vigor mas essa organização não possui nenhum servidor cadastrado como \"Produção\".";
    const ALE_EMPTY_COLLECTOR_AND_DATABASE_VARIABEL_MEASURE = "Atenção! <br> Esse produto possui configurações do tipo \"SQL\" para realizar a coleta de medidas variáveis mas não foram cadastrados os dados do \"Coletor\" e \"Banco de Dados\" para essa organização.";
}
