/* Tabela ITLANCTOEST: Item do Lanamento de Estoque */
/* Descrio: A trigger insere registros na tabela LOGOPERA a partir de alteraes na tabela ITLANCTOEST */
/* Objetivo: Gerar um log que vai registrar as alteraes na tabela Item do Lanamento de Estoque,
             utilizando a tabela Geral de Logs de Operaes */

IF EXISTS(SELECT *
          FROM SYSOBJECTS O, SYSUSERS U
          WHERE O.NAME = 'LOG_EST_ITLANCTOEST' AND
                TYPE   = 'TR'              AND
                U.UID  = O.UID             AND
                U.NAME = USER)

DROP TRIGGER LOG_EST_ITLANCTOEST
GO


CREATE TRIGGER LOG_EST_ITLANCTOEST
ON ITLANCTOEST
FOR UPDATE,INSERT, DELETE
AS
BEGIN

  DECLARE @V_USUARIO          VARCHAR(40);
  DECLARE @V_TIPO             VARCHAR(1);
  DECLARE @V_TPMOVI             VARCHAR(1);
  DECLARE @V_ITPESQ           VARCHAR(40);
  DECLARE @V_DESC             VARCHAR(300);
  DECLARE @V_CDFILLOGOPER     VARCHAR(4);
  DECLARE @V_DTOPER           DATETIME;
  DECLARE @V_DSREMOTEADDR     VARCHAR(15);
  DECLARE @V_DSREMOTEHOST     VARCHAR(15);
  DECLARE @V_DSSERVERRDM      VARCHAR(20);
  DECLARE @V_DSSERVMETHOD     VARCHAR(30);
  DECLARE @V_DSREMOTEOPER     VARCHAR(12);

  DECLARE @V_CDPRODUTO_NEW    VARCHAR(10);
  DECLARE @V_QTLANCTOEST_NEW  NUMERIC(15,5);
  DECLARE @V_VRUNILANCTO_NEW  NUMERIC(15,5);
  DECLARE @V_VRTOTLANCTO_NEW  NUMERIC(15,5);
  DECLARE @V_IDTIPOMOVI_NEW   VARCHAR(2);
  DECLARE @V_DTLANCMOVI_NEW   DATETIME;
  DECLARE @V_IDORDEMCLC_NEW   VARCHAR(2);
  DECLARE @V_VRLANCTOEST_NEW  NUMERIC(15,5);
  DECLARE @V_IDALTCMEDMV_NEW  VARCHAR(2);
  DECLARE @V_QTTOTLANCTO_NEW  NUMERIC(15,5);
  DECLARE @V_CDPRODMOVI_NEW   VARCHAR(10);
  DECLARE @V_VRLANCTOBRUT_NEW NUMERIC(15,5);
  DECLARE @V_IDEVOLESTOQ_NEW  VARCHAR(2);
  DECLARE @V_CDFILIMOVI_NEW   VARCHAR(4);
  DECLARE @V_CDALMOXARIFE_NEW VARCHAR(6);
  DECLARE @V_CDLOCALESTOQ_NEW VARCHAR(6);
  DECLARE @V_NRLOTEESTQ_NEW   VARCHAR(10);
  DECLARE @V_NRSUBLOTE_NEW    VARCHAR(10);
  DECLARE @V_NRLANCORIGRP_NEW VARCHAR(10);
  DECLARE @V_CDCENTCUST_NEW   VARCHAR(10);
  DECLARE @V_CDTIPORETI_NEW   VARCHAR(4);
  DECLARE @V_CDFILIALPED_NEW  VARCHAR(4);
  DECLARE @V_NRPEDIDO_NEW     VARCHAR(10);
  DECLARE @V_NRITEMPED_NEW    VARCHAR(10);
  DECLARE @V_QTDEVOLESTOQ_NEW NUMERIC(15,5);
  DECLARE @V_CDOPERADOR_NEW   VARCHAR(20);

  DECLARE @V_CDPRODUTO_OLD    VARCHAR(10);
  DECLARE @V_QTLANCTOEST_OLD  NUMERIC(15,5);
  DECLARE @V_VRUNILANCTO_OLD  NUMERIC(15,5);
  DECLARE @V_VRTOTLANCTO_OLD  NUMERIC(15,5);
  DECLARE @V_IDTIPOMOVI_OLD   VARCHAR(2);
  DECLARE @V_DTLANCMOVI_OLD   DATETIME;
  DECLARE @V_IDORDEMCLC_OLD   VARCHAR(2);
  DECLARE @V_VRLANCTOEST_OLD  NUMERIC(15,5);
  DECLARE @V_IDALTCMEDMV_OLD  VARCHAR(2);
  DECLARE @V_QTTOTLANCTO_OLD  NUMERIC(15,5);
  DECLARE @V_CDPRODMOVI_OLD   VARCHAR(10);
  DECLARE @V_VRLANCTOBRUT_OLD NUMERIC(15,5);
  DECLARE @V_IDEVOLESTOQ_OLD  VARCHAR(2);
  DECLARE @V_CDFILIMOVI_OLD   VARCHAR(4);
  DECLARE @V_CDALMOXARIFE_OLD VARCHAR(6);
  DECLARE @V_CDLOCALESTOQ_OLD VARCHAR(6);
  DECLARE @V_NRLOTEESTQ_OLD   VARCHAR(10);
  DECLARE @V_NRSUBLOTE_OLD    VARCHAR(10);
  DECLARE @V_NRLANCORIGRP_OLD VARCHAR(10);
  DECLARE @V_CDCENTCUST_OLD   VARCHAR(10);
  DECLARE @V_CDTIPORETI_OLD   VARCHAR(4);
  DECLARE @V_CDFILIALPED_OLD  VARCHAR(4);
  DECLARE @V_NRPEDIDO_OLD     VARCHAR(10);
  DECLARE @V_NRITEMPED_OLD    VARCHAR(10);
  DECLARE @V_QTDEVOLESTOQ_OLD NUMERIC(15,5);
  DECLARE @V_CDOPERADOR_OLD   VARCHAR(20);
  DECLARE @V_NMOPERADOR       VARCHAR(40);
  DECLARE @V_CDFILIAL_OLD     VARCHAR(04);
  DECLARE @V_CDFILIAL_NEW       VARCHAR(04);
  DECLARE @V_NRLANCTOESTQ_OLD   VARCHAR(10);
  DECLARE @V_NRLANCTOESTQ_NEW   VARCHAR(10);
  DECLARE @V_NRSEQUITEM_OLD     VARCHAR(10);
  DECLARE @V_NRSEQUITEM_NEW     VARCHAR(10);


/* IDTIPOOPER - '1' - Incluso, '2' - Alterao, '3' - Excluso*/

   SET @V_DSREMOTEADDR = ' ';
   SET @V_DSREMOTEHOST = ' ';
   SET @V_DSSERVERRDM  = ' ';
   SET @V_DSSERVMETHOD = ' ';
   SET @V_DSREMOTEOPER = ' ';


   EXEC NMUSUARIO @V_NMOPERADOR;
   EXEC WEBTUNNING @V_DSREMOTEADDR,
                   @V_DSREMOTEHOST,
                   @V_DSSERVERRDM,
                   @V_DSSERVMETHOD,
                   @V_DSREMOTEOPER;

  SET @V_TPMOVI = '0';
  SET @V_DESC = '';
  SET @V_CDFILLOGOPER = '';

   DECLARE C_CURSOR_IT CURSOR FOR
      SELECT
         'D' IDCOMANDO,
         NULL, NULL, NULL, NULL, NULL,
         NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL,
         NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL,
         CDFILIAL,               
         NRLANCESTQ,             
         NRSEQUITEM,             
         CDPRODUTO,              
         QTLANCTOEST,            
         VRUNILANCTO,            
         VRTOTLANCTO,            
         IDTIPOMOVI,             
         DTLANCMOVI,             
         IDORDEMCLC,             
         VRLANCTOEST,            
         IDALTCMEDMV,            
         QTTOTLANCTO,            
         CDPRODMOVI,             
         VRLANCTOBRUT,           
         IDEVOLESTOQ,            
         CDFILIMOVI,             
         CDALMOXARIFE,           
         CDLOCALESTOQ,           
         NRLOTEESTQ,             
         NRSUBLOTE,              
         NRLANCORIGRP,           
         CDCENTCUST,             
         CDTIPORETI,             
         CDFILIALPED,            
         NRPEDIDO,               
         NRITEMPED,              
         QTDEVOLESTOQ,           
         CDOPERADOR              
      FROM
         DELETED
      WHERE
         0 = (SELECT COUNT(*) FROM INSERTED)

      UNION ALL

      SELECT
         'U' IDCOMANDO,
         INSERTED.CDFILIAL,
         INSERTED.NRLANCESTQ,
         INSERTED.NRSEQUITEM,
         INSERTED.CDPRODUTO,
         INSERTED.QTLANCTOEST,
         INSERTED.VRUNILANCTO,
         INSERTED.VRTOTLANCTO,
         INSERTED.IDTIPOMOVI,
         INSERTED.DTLANCMOVI,
         INSERTED.IDORDEMCLC,
         INSERTED.VRLANCTOEST,
         INSERTED.IDALTCMEDMV,
         INSERTED.QTTOTLANCTO,
         INSERTED.CDPRODMOVI,
         INSERTED.VRLANCTOBRUT,
         INSERTED.IDEVOLESTOQ,
         INSERTED.CDFILIMOVI,
         INSERTED.CDALMOXARIFE,
         INSERTED.CDLOCALESTOQ,
         INSERTED.NRLOTEESTQ,
         INSERTED.NRSUBLOTE,
         INSERTED.NRLANCORIGRP,
         INSERTED.CDCENTCUST,
         INSERTED.CDTIPORETI,
         INSERTED.CDFILIALPED,
         INSERTED.NRPEDIDO,
         INSERTED.NRITEMPED,
         INSERTED.QTDEVOLESTOQ,
         INSERTED.CDOPERADOR,
         DELETED.CDFILIAL,
         DELETED.NRLANCESTQ,
         DELETED.NRSEQUITEM,
         DELETED.CDPRODUTO,
         DELETED.QTLANCTOEST,
         DELETED.VRUNILANCTO,
         DELETED.VRTOTLANCTO,
         DELETED.IDTIPOMOVI,
         DELETED.DTLANCMOVI,
         DELETED.IDORDEMCLC,
         DELETED.VRLANCTOEST,
         DELETED.IDALTCMEDMV,
         DELETED.QTTOTLANCTO,
         DELETED.CDPRODMOVI,
         DELETED.VRLANCTOBRUT,
         DELETED.IDEVOLESTOQ,
         DELETED.CDFILIMOVI,
         DELETED.CDALMOXARIFE,
         DELETED.CDLOCALESTOQ,
         DELETED.NRLOTEESTQ,
         DELETED.NRSUBLOTE,
         DELETED.NRLANCORIGRP,
         DELETED.CDCENTCUST,
         DELETED.CDTIPORETI,
         DELETED.CDFILIALPED,
         DELETED.NRPEDIDO,
         DELETED.NRITEMPED,
         DELETED.QTDEVOLESTOQ,
         DELETED.CDOPERADOR
      FROM
         INSERTED,
         DELETED
      WHERE
         INSERTED.CDFILIAL    = DELETED.CDFILIAL    AND
         INSERTED.NRLANCESTQ  = DELETED.NRLANCESTQ  AND
         INSERTED.NRSEQUITEM  = DELETED.NRSEQUITEM

      UNION ALL

      SELECT
         'I' IDCOMANDO,
         INSERTED.CDFILIAL,
         INSERTED.NRLANCESTQ,
         INSERTED.NRSEQUITEM,
         INSERTED.CDPRODUTO,
         INSERTED.QTLANCTOEST,
         INSERTED.VRUNILANCTO,
         INSERTED.VRTOTLANCTO,
         INSERTED.IDTIPOMOVI,
         INSERTED.DTLANCMOVI,
         INSERTED.IDORDEMCLC,
         INSERTED.VRLANCTOEST,
         INSERTED.IDALTCMEDMV,
         INSERTED.QTTOTLANCTO,
         INSERTED.CDPRODMOVI,
         INSERTED.VRLANCTOBRUT,
         INSERTED.IDEVOLESTOQ,
         INSERTED.CDFILIMOVI,
         INSERTED.CDALMOXARIFE,
         INSERTED.CDLOCALESTOQ,
         INSERTED.NRLOTEESTQ,
         INSERTED.NRSUBLOTE,
         INSERTED.NRLANCORIGRP,
         INSERTED.CDCENTCUST,
         INSERTED.CDTIPORETI,
         INSERTED.CDFILIALPED,
         INSERTED.NRPEDIDO,
         INSERTED.NRITEMPED,
         INSERTED.QTDEVOLESTOQ,
         INSERTED.CDOPERADOR,
         NULL, NULL, NULL, NULL, NULL,
         NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL,
         NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL
      FROM
         INSERTED
      WHERE
         0 = (SELECT COUNT(*) FROM DELETED)

   OPEN C_CURSOR_IT;
   FETCH NEXT FROM C_CURSOR_IT INTO @V_TIPO,             @V_CDFILIAL_NEW,    @V_NRLANCTOESTQ_NEW, @V_NRSEQUITEM_NEW,
                                 @V_CDPRODUTO_NEW,    @V_QTLANCTOEST_NEW, @V_VRUNILANCTO_NEW,  @V_VRTOTLANCTO_NEW,
                                 @V_IDTIPOMOVI_NEW,   @V_DTLANCMOVI_NEW,  @V_IDORDEMCLC_NEW,   @V_VRLANCTOEST_NEW,
                                 @V_IDALTCMEDMV_NEW,  @V_QTTOTLANCTO_NEW, @V_CDPRODMOVI_NEW,   @V_VRLANCTOBRUT_NEW,
                                 @V_IDEVOLESTOQ_NEW,  @V_CDFILIMOVI_NEW,  @V_CDALMOXARIFE_NEW, @V_CDLOCALESTOQ_NEW,
                                 @V_NRLOTEESTQ_NEW,   @V_NRSUBLOTE_NEW,   @V_NRLANCORIGRP_NEW, @V_CDCENTCUST_NEW,
                                 @V_CDTIPORETI_NEW,   @V_CDFILIALPED_NEW, @V_NRPEDIDO_NEW,     @V_NRITEMPED_NEW,    @V_QTDEVOLESTOQ_NEW,
                                 @V_CDOPERADOR_NEW,   @V_CDFILIAL_OLD,    @V_NRLANCTOESTQ_OLD, @V_NRSEQUITEM_OLD,   @V_CDPRODUTO_OLD,
                                 @V_QTLANCTOEST_OLD,  @V_VRUNILANCTO_OLD, @V_VRTOTLANCTO_OLD,  @V_IDTIPOMOVI_OLD,   @V_DTLANCMOVI_OLD,
                                 @V_IDORDEMCLC_OLD,   @V_VRLANCTOEST_OLD, @V_IDALTCMEDMV_OLD,  @V_QTTOTLANCTO_OLD,  @V_CDPRODMOVI_OLD,
                                 @V_VRLANCTOBRUT_OLD, @V_IDEVOLESTOQ_OLD, @V_CDFILIMOVI_OLD,   @V_CDALMOXARIFE_OLD, @V_CDLOCALESTOQ_OLD,
                                 @V_NRLOTEESTQ_OLD,   @V_NRSUBLOTE_OLD,   @V_NRLANCORIGRP_OLD, @V_CDCENTCUST_OLD,   @V_CDTIPORETI_OLD,
                                 @V_CDFILIALPED_OLD,  @V_NRPEDIDO_OLD,    @V_NRITEMPED_OLD,    @V_QTDEVOLESTOQ_OLD, @V_CDOPERADOR_OLD;

   WHILE (@@FETCH_STATUS = 0) BEGIN
      IF (@V_TIPO = 'D') BEGIN
         IF @V_CDPRODUTO_OLD IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + 'Prod=' + @V_CDPRODUTO_OLD;
         END;

         IF @V_QTLANCTOEST_OLD IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + ' QtLancEst=' + CONVERT(VARCHAR,ROUND(@V_QTLANCTOEST_OLD, 5));
         END;

         IF @V_VRUNILANCTO_OLD IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + ' VrUniLanc=' + CONVERT(VARCHAR,ROUND(@V_VRUNILANCTO_OLD, 5));
         END;

         IF @V_VRTOTLANCTO_OLD IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + ' VrTotaLanc=' + CONVERT(VARCHAR,ROUND(@V_VRTOTLANCTO_OLD, 5));
         END;

         IF @V_IDTIPOMOVI_OLD IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + ' TipoMovi=' + @V_IDTIPOMOVI_OLD;
         END;

         IF @V_DTLANCMOVI_OLD IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + ' DtLanc=' + CONVERT(VARCHAR,@V_DTLANCMOVI_OLD);
         END;

         IF @V_IDORDEMCLC_OLD IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + ' OrdCLC=' + @V_IDORDEMCLC_OLD;
         END;

         IF @V_VRLANCTOEST_OLD IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + ' VrLancEst=' + CONVERT(VARCHAR,ROUND(@V_VRLANCTOEST_OLD, 5));
         END;

         IF @V_IDALTCMEDMV_OLD IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + ' AltCMed=' + @V_IDALTCMEDMV_OLD;
         END;

         IF @V_QTTOTLANCTO_OLD IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + ' QtTota=' + CONVERT(VARCHAR,ROUND(@V_QTTOTLANCTO_OLD, 5));
         END;

         IF @V_CDPRODMOVI_OLD IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + ' ProdMovi=' + @V_CDPRODMOVI_OLD;
         END;

         IF @V_VRLANCTOBRUT_OLD IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + ' VrBruto=' + CONVERT(VARCHAR,ROUND(@V_VRLANCTOBRUT_OLD, 5));
         END;

         IF @V_IDEVOLESTOQ_OLD IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + ' EvolEstoq=' + @V_IDEVOLESTOQ_OLD;
         END;

         IF @V_CDFILIMOVI_OLD IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + ' FiliMovi=' + @V_CDFILIMOVI_OLD;
         END;

         IF @V_CDALMOXARIFE_OLD IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + ' Almox=' + @V_CDALMOXARIFE_OLD;
         END;

         IF @V_CDLOCALESTOQ_OLD IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + ' LcEstoq=' + @V_CDLOCALESTOQ_OLD;
         END;

         IF @V_NRLOTEESTQ_OLD IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + ' Lote=' + @V_NRLOTEESTQ_OLD;
         END;

         IF @V_NRSUBLOTE_OLD IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + ' SubLote=' + @V_NRSUBLOTE_OLD;
         END;

         IF @V_NRLANCORIGRP_OLD IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + ' LancOrig=' + @V_NRLANCORIGRP_OLD;
         END;

         IF @V_CDCENTCUST_OLD IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + ' CCusto=' + @V_CDCENTCUST_OLD;
         END;

         IF @V_CDTIPORETI_OLD IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + ' TipoReti=' + @V_CDTIPORETI_OLD;
         END;

         IF @V_CDFILIALPED_OLD IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + ' FiliPED=' + @V_CDFILIALPED_OLD;
         END;

         IF @V_NRPEDIDO_OLD IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + ' NRPedido=' + @V_NRPEDIDO_OLD;
         END;

         IF @V_NRITEMPED_OLD IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + ' ItemPED' + @V_NRITEMPED_OLD;
         END;

         IF @V_QTDEVOLESTOQ_OLD IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + ' QtDevol=' + CONVERT(VARCHAR,ROUND(@V_QTDEVOLESTOQ_OLD, 5));
         END;

         IF @V_CDOPERADOR_OLD IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + ' Operador=' + @V_CDOPERADOR_OLD;
         END;

         SET @V_TPMOVI         = '3';
         SET @V_ITPESQ       = @V_CDFILIAL_OLD + @V_NRLANCTOESTQ_OLD + @V_NRSEQUITEM_OLD;
         SET @V_CDFILLOGOPER = @V_CDFILIAL_OLD;
      END
      ELSE BEGIN
         IF @V_TIPO = 'U' BEGIN
            IF (ISNULL(@V_CDPRODUTO_OLD ,'!')   <> ISNULL(@V_CDPRODUTO_NEW,'!'))    OR
               (ISNULL(@V_QTLANCTOEST_OLD,0 )   <> ISNULL(@V_QTLANCTOEST_NEW,0))    OR
               (ISNULL(@V_VRUNILANCTO_OLD,0)    <> ISNULL(@V_VRUNILANCTO_NEW,0))    OR
               (ISNULL(@V_VRTOTLANCTO_OLD,0)    <> ISNULL(@V_VRTOTLANCTO_NEW,0))    OR
               (ISNULL(@V_IDTIPOMOVI_OLD,'!')   <> ISNULL(@V_IDTIPOMOVI_NEW,'!'))   OR
               (ISNULL(@V_DTLANCMOVI_OLD,GETDATE())   <> ISNULL(@V_DTLANCMOVI_NEW,GETDATE()))  OR
               (ISNULL(@V_IDORDEMCLC_OLD,'!')   <> ISNULL(@V_IDORDEMCLC_NEW,'!'))   OR
               (ISNULL(@V_VRLANCTOEST_OLD,0 )   <> ISNULL(@V_VRLANCTOEST_NEW, 0))   OR
               (ISNULL(@V_IDALTCMEDMV_OLD,'!')  <> ISNULL(@V_IDALTCMEDMV_NEW,'!'))  OR
               (ISNULL(@V_QTTOTLANCTO_OLD,0)    <> ISNULL(@V_QTTOTLANCTO_NEW,0))    OR
               (ISNULL(@V_CDPRODMOVI_OLD,'!')   <> ISNULL(@V_CDPRODMOVI_NEW,'!'))   OR
               (ISNULL(@V_VRLANCTOBRUT_OLD,0)   <> ISNULL(@V_VRLANCTOBRUT_NEW,0))   OR
               (ISNULL(@V_IDEVOLESTOQ_OLD,'!')  <> ISNULL(@V_IDEVOLESTOQ_NEW,'!'))  OR
               (ISNULL(@V_CDFILIMOVI_OLD,'!')   <> ISNULL(@V_CDFILIMOVI_NEW,'!'))   OR
               (ISNULL(@V_CDALMOXARIFE_OLD,'!') <> ISNULL(@V_CDALMOXARIFE_NEW,'!')) OR
               (ISNULL(@V_CDLOCALESTOQ_OLD,'!') <> ISNULL(@V_CDLOCALESTOQ_NEW,'!')) OR
               (ISNULL(@V_NRLOTEESTQ_OLD,'!')   <> ISNULL(@V_NRLOTEESTQ_NEW,'!'))   OR
               (ISNULL(@V_NRSUBLOTE_OLD,'!')    <> ISNULL(@V_NRSUBLOTE_NEW,'!'))    OR
               (ISNULL(@V_NRLANCORIGRP_OLD,'!') <> ISNULL(@V_NRLANCORIGRP_NEW,'!')) OR
               (ISNULL(@V_CDCENTCUST_OLD,'!')   <> ISNULL(@V_CDCENTCUST_NEW,'!'))   OR
               (ISNULL(@V_CDTIPORETI_OLD,'!')   <> ISNULL(@V_CDTIPORETI_NEW,'!'))   OR
               (ISNULL(@V_CDFILIALPED_OLD,'!')  <> ISNULL(@V_CDFILIALPED_NEW,'!'))  OR
               (ISNULL(@V_NRPEDIDO_OLD,'!')     <> ISNULL(@V_NRPEDIDO_NEW,'!'))     OR
               (ISNULL(@V_NRITEMPED_OLD,'!')    <> ISNULL(@V_NRITEMPED_NEW,'!'))    OR
               (ISNULL(@V_QTDEVOLESTOQ_OLD, 0)  <> ISNULL(@V_QTDEVOLESTOQ_NEW,0))   OR
               (ISNULL(@V_CDOPERADOR_OLD,'!') <> ISNULL(@V_CDOPERADOR_OLD,'!'))BEGIN

               IF ISNULL(@V_CDPRODUTO_NEW,'!') <> ISNULL(@V_CDPRODUTO_OLD,'!') BEGIN
                  SET @V_DESC = @V_DESC + 'Prod=' + @V_CDPRODUTO_NEW;
               END;

               IF ISNULL(@V_QTLANCTOEST_NEW,0) <> ISNULL(@V_QTLANCTOEST_OLD,0) BEGIN
                  SET @V_DESC = @V_DESC + ' QtLancEst=' + CONVERT(VARCHAR,ROUND(@V_QTLANCTOEST_NEW, 5));
               END;

               IF ISNULL(@V_VRUNILANCTO_NEW,0) <> ISNULL(@V_VRUNILANCTO_OLD,0) BEGIN
                  SET @V_DESC = @V_DESC + ' VrUniLanc=' + CONVERT(VARCHAR,ROUND(@V_VRUNILANCTO_NEW, 5));
               END;

               IF ISNULL(@V_VRTOTLANCTO_NEW,0) <> ISNULL(@V_VRTOTLANCTO_OLD,0) BEGIN
                  SET @V_DESC = @V_DESC + ' VrTotaLanc=' + CONVERT(VARCHAR,ROUND(@V_VRTOTLANCTO_NEW, 5));
               END;

               IF ISNULL(@V_IDTIPOMOVI_NEW,'!') <> ISNULL(@V_IDTIPOMOVI_OLD,'!') BEGIN
                  SET @V_DESC = @V_DESC + ' TipoMovi=' + @V_IDTIPOMOVI_NEW;
               END;

               IF ISNULL(@V_DTLANCMOVI_NEW,GETDATE()) <> ISNULL(@V_DTLANCMOVI_OLD,GETDATE()) BEGIN
                  SET @V_DESC = @V_DESC + ' DtLanc=' + CONVERT(VARCHAR,@V_DTLANCMOVI_NEW);
               END;

               IF ISNULL(@V_IDORDEMCLC_NEW,'!') <> ISNULL(@V_IDORDEMCLC_OLD,'!') BEGIN
                  SET @V_DESC = @V_DESC + ' OrdCLC=' + @V_IDORDEMCLC_NEW;
               END;

               IF ISNULL(@V_VRLANCTOEST_NEW, 0) <> ISNULL(@V_VRLANCTOEST_OLD, 0 ) BEGIN
                  SET @V_DESC = @V_DESC + ' VrLancEst=' + CONVERT(VARCHAR,ROUND(@V_VRLANCTOEST_NEW, 5));
               END;

               IF ISNULL(@V_IDALTCMEDMV_NEW, '!') <> ISNULL(@V_IDALTCMEDMV_OLD, '!' ) BEGIN
                  SET @V_DESC = @V_DESC + ' AltCMed=' + @V_IDALTCMEDMV_NEW;
               END;

               IF ISNULL(@V_QTTOTLANCTO_NEW, 0) <> ISNULL(@V_QTTOTLANCTO_OLD, 0 ) BEGIN
                  SET @V_DESC = @V_DESC + ' QtTota=' + CONVERT(VARCHAR,ROUND(@V_QTTOTLANCTO_NEW, 5));
               END;

               IF ISNULL(@V_CDPRODMOVI_NEW, '!') <> ISNULL(@V_CDPRODMOVI_OLD, '!' ) BEGIN
                  SET @V_DESC = @V_DESC + ' ProdMovi=' + @V_CDPRODMOVI_NEW;
               END;

               IF ISNULL(@V_VRLANCTOBRUT_NEW, 0) <> ISNULL(@V_VRLANCTOBRUT_OLD, 0) BEGIN
                  SET @V_DESC = @V_DESC + ' VrBruto=' + CONVERT(VARCHAR,ROUND(@V_VRLANCTOBRUT_NEW, 5));
               END;

               IF ISNULL(@V_IDEVOLESTOQ_NEW, '!') <> ISNULL(@V_IDEVOLESTOQ_OLD, '!') BEGIN
                  SET @V_DESC = @V_DESC + ' EvolEstoq=' + @V_IDEVOLESTOQ_NEW;
               END;

               IF ISNULL(@V_CDFILIMOVI_NEW, '!') <> ISNULL(@V_CDFILIMOVI_OLD, '!') BEGIN
                  SET @V_DESC = @V_DESC + ' FiliMovi=' + @V_CDFILIMOVI_NEW;
               END;

               IF ISNULL(@V_CDALMOXARIFE_NEW, '!') <> ISNULL(@V_CDALMOXARIFE_OLD, '!') BEGIN
                  SET @V_DESC = @V_DESC + ' Almox=' + @V_CDALMOXARIFE_NEW;
               END;

               IF ISNULL(@V_CDLOCALESTOQ_NEW, '!') <> ISNULL(@V_CDLOCALESTOQ_OLD, '!') BEGIN
                  SET @V_DESC = @V_DESC + ' LcEstoq=' + @V_CDLOCALESTOQ_NEW;
               END;

               IF ISNULL(@V_NRLOTEESTQ_NEW, '!') <> ISNULL(@V_NRLOTEESTQ_OLD, '!') BEGIN
                  SET @V_DESC = @V_DESC + ' Lote=' + @V_NRLOTEESTQ_NEW;
               END;

               IF ISNULL(@V_NRSUBLOTE_NEW, '!') <> ISNULL(@V_NRSUBLOTE_OLD, '!') BEGIN
                  SET @V_DESC = @V_DESC + ' SubLote=' + @V_NRSUBLOTE_NEW;
               END;

               IF ISNULL(@V_NRLANCORIGRP_NEW, '!') <> ISNULL(@V_NRLANCORIGRP_OLD, '!') BEGIN
                  SET @V_DESC = @V_DESC + ' LancOrig=' + @V_NRLANCORIGRP_NEW;
               END;

               IF ISNULL(@V_CDCENTCUST_NEW, '!') <> ISNULL(@V_CDCENTCUST_OLD, '!') BEGIN
                  SET @V_DESC = @V_DESC + ' CCusto=' + @V_CDCENTCUST_NEW;
               END;

               IF ISNULL(@V_CDTIPORETI_NEW, '!') <> ISNULL(@V_CDTIPORETI_OLD, '!') BEGIN
                  SET @V_DESC = @V_DESC + ' TipoReti=' + @V_CDTIPORETI_NEW;
               END;

               IF ISNULL(@V_CDFILIALPED_NEW, '!') <> ISNULL(@V_CDFILIALPED_OLD, '!') BEGIN
                  SET @V_DESC = @V_DESC + ' FiliPED=' + @V_CDFILIALPED_NEW;
               END;

               IF ISNULL(@V_NRPEDIDO_NEW, '!') <> ISNULL(@V_NRPEDIDO_OLD, '!') BEGIN
                  SET @V_DESC = @V_DESC + ' NRPedido=' + @V_NRPEDIDO_NEW;
               END;

               IF ISNULL(@V_NRITEMPED_NEW, '!') <> ISNULL(@V_NRITEMPED_OLD, '!') BEGIN
                  SET @V_DESC = @V_DESC + ' ItemPED' + @V_NRITEMPED_NEW;
               END;

               IF ISNULL(@V_QTDEVOLESTOQ_NEW, 0) <> ISNULL(@V_QTDEVOLESTOQ_OLD, 0) BEGIN
                  SET @V_DESC = @V_DESC + ' QtDevol=' + CONVERT(VARCHAR,ROUND(@V_QTDEVOLESTOQ_NEW, 5));
               END;

               IF @V_CDOPERADOR_NEW IS NOT NULL BEGIN
                  SET @V_DESC = @V_DESC + ' Operador=' + @V_CDOPERADOR_NEW;
               END;

               SET @V_TPMOVI         = '2';
               SET @V_ITPESQ       = @V_CDFILIAL_OLD + @V_NRLANCTOESTQ_OLD + @V_NRSEQUITEM_OLD;
               SET @V_CDFILLOGOPER = @V_CDFILIAL_OLD;
            END;
         END
         ELSE BEGIN
            IF @V_CDPRODUTO_NEW IS NOT NULL BEGIN
               SET @V_DESC = @V_DESC + 'Prod=' + @V_CDPRODUTO_NEW;
            END;

            IF @V_QTLANCTOEST_NEW IS NOT NULL BEGIN
               SET @V_DESC = @V_DESC + ' QtLancEst=' + CONVERT(VARCHAR,ROUND(@V_QTLANCTOEST_NEW, 5));
            END;

            IF @V_VRUNILANCTO_NEW IS NOT NULL BEGIN
               SET @V_DESC = @V_DESC + ' VrUniLanc=' + CONVERT(VARCHAR,ROUND(@V_VRUNILANCTO_NEW, 5));
            END;

            IF @V_VRTOTLANCTO_NEW IS NOT NULL BEGIN
               SET @V_DESC = @V_DESC + ' VrTotaLanc=' + CONVERT(VARCHAR,ROUND(@V_VRTOTLANCTO_NEW, 5));
            END;

            IF @V_IDTIPOMOVI_NEW IS NOT NULL BEGIN
               SET @V_DESC = @V_DESC + ' TipoMovi=' + @V_IDTIPOMOVI_NEW;
            END;

            IF @V_DTLANCMOVI_NEW IS NOT NULL BEGIN
               SET @V_DESC = @V_DESC + ' DtLanc=' + CONVERT(VARCHAR,@V_DTLANCMOVI_NEW);
            END;

            IF @V_IDORDEMCLC_NEW IS NOT NULL BEGIN
               SET @V_DESC = @V_DESC + ' OrdCLC=' + @V_IDORDEMCLC_NEW;
            END;

            IF @V_VRLANCTOEST_NEW IS NOT NULL BEGIN
               SET @V_DESC = @V_DESC + ' VrLancEst=' + CONVERT(VARCHAR,ROUND(@V_VRLANCTOEST_NEW, 5));
            END;

            IF @V_IDALTCMEDMV_NEW IS NOT NULL BEGIN
               SET @V_DESC = @V_DESC + ' AltCMed=' + @V_IDALTCMEDMV_NEW;
            END;

            IF @V_QTTOTLANCTO_NEW IS NOT NULL BEGIN
               SET @V_DESC = @V_DESC + ' QtTota=' + CONVERT(VARCHAR,ROUND(@V_QTTOTLANCTO_NEW, 5));
            END;

            IF @V_CDPRODMOVI_NEW IS NOT NULL BEGIN
               SET @V_DESC = @V_DESC + ' ProdMovi=' + @V_CDPRODMOVI_NEW;
            END;

            IF @V_VRLANCTOBRUT_NEW IS NOT NULL BEGIN
               SET @V_DESC = @V_DESC + ' VrBruto=' + CONVERT(VARCHAR,ROUND(@V_VRLANCTOBRUT_NEW, 5));
            END;

            IF @V_IDEVOLESTOQ_NEW IS NOT NULL BEGIN
               SET @V_DESC = @V_DESC + ' EvolEstoq=' + @V_IDEVOLESTOQ_NEW;
            END;

            IF @V_CDFILIMOVI_NEW IS NOT NULL BEGIN
               SET @V_DESC = @V_DESC + ' FiliMovi=' + @V_CDFILIMOVI_NEW;
            END;

            IF @V_CDALMOXARIFE_NEW IS NOT NULL BEGIN
               SET @V_DESC = @V_DESC + ' Almox=' + @V_CDALMOXARIFE_NEW;
            END;

            IF @V_CDLOCALESTOQ_NEW IS NOT NULL BEGIN
               SET @V_DESC = @V_DESC + ' LcEstoq=' + @V_CDLOCALESTOQ_NEW;
            END;

            IF @V_NRLOTEESTQ_NEW IS NOT NULL BEGIN
               SET @V_DESC = @V_DESC + ' Lote=' + @V_NRLOTEESTQ_NEW;
            END;

            IF @V_NRSUBLOTE_NEW IS NOT NULL BEGIN
               SET @V_DESC = @V_DESC + ' SubLote=' + @V_NRSUBLOTE_NEW;
            END;

            IF @V_NRLANCORIGRP_NEW IS NOT NULL BEGIN
               SET @V_DESC = @V_DESC + ' LancOrig=' + @V_NRLANCORIGRP_NEW;
            END;

            IF @V_CDCENTCUST_NEW IS NOT NULL BEGIN
               SET @V_DESC = @V_DESC + ' CCusto=' + @V_CDCENTCUST_NEW;
            END;

            IF @V_CDTIPORETI_NEW IS NOT NULL BEGIN
               SET @V_DESC = @V_DESC + ' TipoReti=' + @V_CDTIPORETI_NEW;
            END;

            IF @V_CDFILIALPED_NEW IS NOT NULL BEGIN
               SET @V_DESC = @V_DESC + ' FiliPED=' + @V_CDFILIALPED_NEW;
            END;

            IF @V_NRPEDIDO_NEW IS NOT NULL BEGIN
               SET @V_DESC = @V_DESC + ' NRPedido=' + @V_NRPEDIDO_NEW;
            END;

            IF @V_NRITEMPED_NEW IS NOT NULL BEGIN
               SET @V_DESC = @V_DESC + ' ItemPED' + @V_NRITEMPED_NEW;
            END;

            IF @V_QTDEVOLESTOQ_NEW IS NOT NULL BEGIN
               SET @V_DESC = @V_DESC + ' QtDevol=' + CONVERT(VARCHAR,ROUND(@V_QTDEVOLESTOQ_NEW, 5));
            END;

            SET @V_TPMOVI       = '1';
            SET @V_ITPESQ       = @V_CDFILIAL_NEW + @V_NRLANCTOESTQ_NEW + @V_NRSEQUITEM_NEW;
            SET @V_CDFILLOGOPER = @V_CDFILIAL_NEW;
         END;
      END;
      EXEC NMUSUARIO @V_USUARIO;

      SET @V_USUARIO = ISNULL(@V_USUARIO, ' ');

      IF @V_TPMOVI <> '0' BEGIN
         IF NOT @V_DESC IS NULL BEGIN
            IF NOT @V_USUARIO IS NULL BEGIN
               SET @V_DTOPER = GETDATE();

               INSERT INTO LOGOPERA
                  (NMTABELA,   DTOPERACAO, NMRESPOPER, IDTIPOOPER, CDPESQITEM, DSOPERACAO, CDFILLOGOPER,
                   DSRDMUSUOPER, DSENDUSUOPER, DSNMUSUOPER, DSMETUSUOPER, CDORESPOPER)
               VALUES
                  ('ITLANCTOEST',   @V_DTOPER, @V_USUARIO,  @V_TPMOVI, @V_ITPESQ, @V_DESC, @V_CDFILLOGOPER,
                   @V_DSREMOTEADDR, @V_DSREMOTEHOST, @V_DSSERVERRDM, @V_DSSERVMETHOD, @V_DSREMOTEOPER);
            END;
         END;
      END;
      FETCH NEXT FROM C_CURSOR_IT INTO @V_TIPO,          @V_CDFILIAL_NEW,    @V_NRLANCTOESTQ_NEW, @V_NRSEQUITEM_NEW,
                                    @V_CDPRODUTO_NEW,    @V_QTLANCTOEST_NEW, @V_VRUNILANCTO_NEW,  @V_VRTOTLANCTO_NEW,
                                    @V_IDTIPOMOVI_NEW,   @V_DTLANCMOVI_NEW,  @V_IDORDEMCLC_NEW,   @V_VRLANCTOEST_NEW,
                                    @V_IDALTCMEDMV_NEW,  @V_QTTOTLANCTO_NEW, @V_CDPRODMOVI_NEW,   @V_VRLANCTOBRUT_NEW,
                                    @V_IDEVOLESTOQ_NEW,  @V_CDFILIMOVI_NEW,  @V_CDALMOXARIFE_NEW, @V_CDLOCALESTOQ_NEW,
                                    @V_NRLOTEESTQ_NEW,   @V_NRSUBLOTE_NEW,   @V_NRLANCORIGRP_NEW, @V_CDCENTCUST_NEW,
                                    @V_CDTIPORETI_NEW,   @V_CDFILIALPED_NEW, @V_NRPEDIDO_NEW,     @V_NRITEMPED_NEW,    @V_QTDEVOLESTOQ_NEW,
                                    @V_CDOPERADOR_NEW,   @V_CDFILIAL_OLD,    @V_NRLANCTOESTQ_OLD, @V_NRSEQUITEM_OLD,   @V_CDPRODUTO_OLD,
                                    @V_QTLANCTOEST_OLD,  @V_VRUNILANCTO_OLD, @V_VRTOTLANCTO_OLD,  @V_IDTIPOMOVI_OLD,   @V_DTLANCMOVI_OLD,
                                    @V_IDORDEMCLC_OLD,   @V_VRLANCTOEST_OLD, @V_IDALTCMEDMV_OLD,  @V_QTTOTLANCTO_OLD,  @V_CDPRODMOVI_OLD,
                                    @V_VRLANCTOBRUT_OLD, @V_IDEVOLESTOQ_OLD, @V_CDFILIMOVI_OLD,   @V_CDALMOXARIFE_OLD, @V_CDLOCALESTOQ_OLD,
                                    @V_NRLOTEESTQ_OLD,   @V_NRSUBLOTE_OLD,   @V_NRLANCORIGRP_OLD, @V_CDCENTCUST_OLD,   @V_CDTIPORETI_OLD,
                                    @V_CDFILIALPED_OLD,  @V_NRPEDIDO_OLD,    @V_NRITEMPED_OLD,    @V_QTDEVOLESTOQ_OLD, @V_CDOPERADOR_OLD;

   END;
   CLOSE C_CURSOR_IT;
   DEALLOCATE C_CURSOR_IT;
END;

GO


-- VERSAO --
EXEC ATUVEROBJ 'LOG_EST_ITLANCTOEST','4.11.105';
GO

